PermanentColour = function(object)
  local colour = 0
  for i=1,5 do      
  	if object:GetColour():Test( i ) ~= 0 then 
		  colour = colour + 1
	  end
	end
  return colour
end

AnotherMulticoloredPermanentYouControl = function(object)
  local mun_mp = 0
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_IN_PLAY )
  filter:SetCardInstance( object )
  filter:AddExtra( FILTER_EXTRA_FLIP_CARD_INSTANCE )
  filter:SetController( object:GetController() )
  local total = filter:EvaluateObjects()
  if total > 0 then
    for i=0,total-1 do
      local card = filter:GetNthEvaluatedObject(i)    			
      if card ~= nil then			
    	  if PermanentColour(card) > 1 then	
    	    mun_mp = mun_mp + 1
    	  end
      end
    end    		
  end 
  return mun_mp
end

FlipCoin = function()
  local chest = math.random(0, 1)
  return chest
end

FlipChance = function(player)
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone( ZONE_IN_PLAY )
  filter:SetController( player )
  filter:AddCardName( "KRARKS_THUMB" )
  local chance = filter:Count() + 1
  return chance
end

CountPermanentsInZoneOfPlayer = function(zone, player)
  local filter = Object():GetFilter()
  filter:Clear()
  filter:SetZone(zone)
  filter:AddCardType(CARD_TYPE_ARTIFACT)
  filter:AddCardType(CARD_TYPE_CREATURE)
  filter:AddCardType(CARD_TYPE_ENCHANTMENT)
  filter:AddCardType(CARD_TYPE_LAND)
  filter:AddCardType(CARD_TYPE_PLANESWALKER)
  filter:SetController(player)
  filter:NotTargetted()
  return filter:Count()
end

CountTypeInZoneOfPlayer = function(type, zone, player)
  local filter = Object():GetFilter()
  filter:Clear()
  filter:SetZone(zone)
  filter:AddCardType(type)
  filter:SetController(player)
  filter:NotTargetted()
  return filter:Count()
end

ShareCardTypeWithObject = function(object, source)
  local cardType = {}
  local j = 0
  if object ~= nil and source ~= nil then
    for i=0,7 do
      if source:GetCardType():Test( i ) ~= 0 then  
        if object:GetCardType():Test( i ) ~= 0 then  
          return 1
        end
      end
    end
  end
  return 0
end

DredgeCardAndValue = function(object)
  local amount = {}
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetCardInstance(object)
  filter:AddCardName( "GRAVESHELL_SCARAB" )
  amount[1] = filter:CountStopAt( 1 )
  filter:AddCardName( "DAKMOR_SALVAGE" )
  filter:AddCardName( "GOLGARI_BROWNSCALE" )
  filter:AddCardName( "MOLDERVINE_CLOAK" )  
  filter:AddCardName( "NECROPLASM" )
  filter:AddCardName( "NIGHTMARE_VOID" )
  amount[2] = filter:CountStopAt( 1 ) - amount[1]
  filter:AddCardName( "DARKBLAST" )
  filter:AddCardName( "GREATER_MOSSDOG" )
  filter:AddCardName( "LIFE_FROM_THE_LOAM" )  
  filter:AddCardName( "SHAMBLING_SHELL" )
  amount[3] = filter:CountStopAt( 1 ) - amount[1] - amount[2]
  filter:AddCardName( "GOLGARI_THUG" )
  amount[4] = filter:CountStopAt( 1 ) - amount[1] - amount[2] - amount[3]
  filter:AddCardName( "STINKWEED_IMP" )
  amount[5] = filter:CountStopAt( 1 ) - amount[1] - amount[2] - amount[3] - amount[4]
  filter:AddCardName( "GOLGARI_GRAVETROLL" )
  amount[6] = filter:CountStopAt( 1 ) - amount[1] - amount[2] - amount[3] - amount[4] - amount[5]
  for i=1,6 do
    if amount[i] > 0 then  
      return i
    end
  end
  return 0
end