ManaTokenType = function(colour)
  local type_MT = {}
  type_MT[0] = "_TOKEN_C_624999"
  type_MT[1] = "_TOKEN_W_624994"
  type_MT[2] = "_TOKEN_U_624995"
  type_MT[3] = "_TOKEN_B_624996"
  type_MT[4] = "_TOKEN_R_624997"
  type_MT[5] = "_TOKEN_G_624998"
  return type_MT[colour]
end

PhyrexianManaCost = function(object, colour)
  local amount = {}
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetCardInstance(object)
  filter:AddCardName( "APOSTLES_BLESSING" )
  filter:AddCardName( "CATHEDRAL_MEMBRANE" )
  filter:AddCardName( "MARROW_SHARDS" )  
  filter:AddCardName( "NORNS_ANNEX" )
  filter:AddCardName( "PORCELAIN_LEGIONNAIRE" )
  amount[1] = filter:CountStopAt( 1 )
  filter:AddCardName( "GITAXIAN_PROBE" )
  filter:AddCardName( "MENTAL_MISSTEP" )
  filter:AddCardName( "PHYREXIAN_METAMORPH" )  
  filter:AddCardName( "SPINED_THOPTER" )
  filter:AddCardName( "TEZZERETS_GAMBIT" )
  amount[2] = filter:CountStopAt( 1 ) - amount[1]
  filter:AddCardName( "DISMEMBER" )
  filter:AddCardName( "PITH_DRILLER" )
  filter:AddCardName( "POSTMORTEM_LUNGE" )  
  filter:AddCardName( "SURGICAL_EXTRACTION" )
  filter:AddCardName( "VAULT_SKIRGE" )
  amount[3] = filter:CountStopAt( 1 ) - amount[1] - amount[2]
  filter:AddCardName( "ACT_OF_AGGRESSION" )
  filter:AddCardName( "GUT_SHOT" )
  filter:AddCardName( "MOLTENSTEEL_DRAGON" )  
  filter:AddCardName( "RAGE_EXTRACTOR" )
  filter:AddCardName( "RUTHLESS_INVASION" )
  filter:AddCardName( "SLASH_PANTHER" )
  amount[4] = filter:CountStopAt( 1 ) - amount[1] - amount[2] - amount[3]
  filter:AddCardName( "BIRTHING_POD" )
  filter:AddCardName( "CORROSIVE_GALE" )
  filter:AddCardName( "MUTAGENIC_GROWTH" )  
  filter:AddCardName( "NOXIOUS_REVIVAL" )
  filter:AddCardName( "THUNDERING_TANADON" )
  amount[5] = filter:CountStopAt( 1 ) - amount[1] - amount[2] - amount[3] - amount[4]
  amount[0] = filter:CountStopAt( 1 )
  return amount[colour]
end

CountNameInPlayOfPlayer = function(name, player, ff)
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone(ZONE_IN_PLAY)
  filter:AddCardName(name)
  if player ~= nil then 
    if ff == 0 then 
      filter:SetController(player)
    elseif ff == 1 then
      filter:SetControllersTeam( player:GetTeam() )
      filter:AddExtra( FILTER_EXTRA_FLIP_TEAM )
    end
  end
  return filter:Count()
end

OpponentsLifeLostThisTurn = function()
-- life your opponents have lost this turn
  local total = 0
  local numPlayers = MTG():GetNumberOfPlayers()
  for i=0,num_players-1 do
    local player = MTG():GetNthPlayer(i)
    if player ~= nil and player:GetTeam() ~= Object():GetPlayer():GetTeam() then
    	total = total + MTG():Interrogate_LifeLostThisTurn(player)
    end
  end
  return lifeLost
end

CountAnimarCounter = function(player)
  local counters = 0
  local filter = Object():GetFilter()
  filter:Clear()
  filter:NotTargetted()
  filter:SetZone(ZONE_IN_PLAY)
  filter:SetController(player)
  filter:AddCardName( "ANIMAR_SOUL_OF_ELEMENTS" )
  local total = filter:EvaluateObjects()
  if total > 0 then
    for i=0,total-1 do
      local card = filter:GetNthEvaluatedObject(i)    			
      if card ~= nil then			
    	  counters = counters + card:CountCounters( MTG():PlusOnePlusOneCounters() )
      end
    end    		
  end
  return counters
end

DecManaCostF = function(object)
  if object:GetCardType():Test( CARD_TYPE_LAND ) == 0 then
    local total = 0
    local player = object:GetOwner()
    if object:GetColour():Test( COLOUR_WHITE ) ~= 0 then
      total = total + CountNameInPlayOfPlayer("PEARL_MEDALLION", player, 0) + CountNameInPlayOfPlayer("GRAND_ARBITER_AUGUSTIN_IV", player, 0)
    end
    if object:GetColour():Test( COLOUR_BLUE ) ~= 0 then
      total = total + CountNameInPlayOfPlayer("SAPPHIRE_MEDALLION", player, 0) + CountNameInPlayOfPlayer("GRAND_ARBITER_AUGUSTIN_IV", player, 0)
    end
    if object:GetColour():Test( COLOUR_BLACK ) ~= 0 then
      total = total + CountNameInPlayOfPlayer("JET_MEDALLION", player, 0)
    end
    if object:GetColour():Test( COLOUR_RED ) ~= 0 then
      total = total + CountNameInPlayOfPlayer("RUBY_MEDALLION", player, 0)
    end
    if object:GetColour():Test( COLOUR_GREEN ) ~= 0 then
      total = total + CountNameInPlayOfPlayer("EMERALD_MEDALLION", player, 0)
    end
    if object:GetCardType():Test( CARD_TYPE_CREATURE ) ~= 0 then
      total = total + (CountNameInPlayOfPlayer("HEARTLESS_SUMMONING", player, 0) * 2) + (CountNameInPlayOfPlayer("RAKDOS_LORD_OF_RIOTS", player, 0) * OpponentsLifeLostThisTurn()) + CountAnimarCounter(player)
    end
    if object:GetCardType():Test( CARD_TYPE_INSTANT ) ~= 0 or object:GetCardType():Test( CARD_TYPE_SORCERY ) ~= 0 then
      total = total + CountNameInPlayOfPlayer("GOBLIN_ELECTROMANCER", player, 0)
    end
    if object:GetSubType():Test(CREATURE_TYPE_ZOMBIE) ~= 0 then
      total = total + CountNameInPlayOfPlayer("UNDEAD_WARCHIEF", player, 0)
    end
    if object:GetSubType():Test(CREATURE_TYPE_GOBLIN) ~= 0 then
      total = total + CountNameInPlayOfPlayer("GOBLIN_WARCHIEF", player, 0)
    end
    if object:GetSubType():Test(CREATURE_TYPE_ELDRAZI) ~= 0 and PermanentColour(object) == 0 then
      total = total + CountNameInPlayOfPlayer("EYE_OF_UGIN", player, 0) * 2
    end
		return total
	else
		return 0
  end
end

IncManaCostF = function(object)
  if object:GetCardType():Test( CARD_TYPE_LAND ) == 0 then
    local player = object:GetOwner()
    local total = CountNameInPlayOfPlayer("GRAND_ARBITER_AUGUSTIN_IV", player, 1)
    if object:GetCardType():Test( CARD_TYPE_CREATURE ) == 0 then
      total = total + CountNameInPlayOfPlayer("THALIA_GUARDIAN_OF_THRABEN", nil, 0)
    end
    if object:GetCardType():Test( CARD_TYPE_ARTIFACT ) == 0 then
      total = total + CountNameInPlayOfPlayer("LODESTONE_GOLEM", nil, 0)
    end
		return total
	else
		return 0
  end
end

ColourToString = function(colour)
-- converts color constants (i.e. COLOUR_RED) to mana strings (i.e. "{R}")
	local mana_table = {"{W}", "{U}", "{B}", "{R}", "{G}"}
	return mana_table[colour]
end

ManaString = function(colour, amount)
-- generates a mana string of the selected color and amount
	local string = ""
	if amount == 0 then
		return "{0}"
	end
	for i=1,amount do
		string = string..ColourToString(colour)
	end
	return string
end

PhyrexianColourToString = function(colour)
-- converts phyrexian color constants (i.e. COLOUR_RED) to mana strings (i.e. "{R/P}")
	local mana_table = {"{W/P}", "{U/P}", "{B/P}", "{R/P}", "{G/P}"}
	return mana_table[colour]
end

PhyrexianManaString = function(colour, amount)
-- generates a mana string of the selected color and amount
	local string = ""
	if amount == 0 then
		return "{0}"
	end
	for i=1,amount do
		string = string..PhyrexianColourToString(colour)
	end
	return string
end

HybridColourToString = function(colour)
-- converts hybrid color constants to mana strings combo (2, 3, 4, 5, 6, 8, 10, 12, 15, 20, 21, 22, 23, 24, 25)
	local mana_table = {"", "{W/U}", "{W/B}", "{R/W}", "{G/W}", "{U/B}", "", "{U/R}", "", "{G/U}", "", "{B/R}", "", "", "{B/G}", "", "", "", "", "{R/G}", "{2/W}", "{2/U}", "{2/B}", "{2/R}", "{2/G}"}
	return mana_table[colour]
end

HybridManaString = function(colour, amount)
-- generates a mana string of the selected hybrid color and amount
	local string = ""
	if amount == 0 then
		return "{0}"
	end
	for i=1,amount do
		string = string..HybridColourToString(colour)
	end
	return string
end

HybridColourCombo = function(object)
  local center = 0
  local combo = 1
  if PermanentColour(object) > 1 then 
    for i=1,5 do      
  	  if object:GetColour():Test( i ) ~= 0 then 
        if PermanentColour(object) ~= 3 or center ~= 1 then 
		      combo = combo * i
	      end
		    center = center + 1
	    end
	  end
	end
  return combo
end

HybridCenterColour = function(object)
  local center = 0
  if PermanentColour(object) == 3 then 
    local combo = HybridColourCombo(object)
    for i=1,5 do      
  	  if i * (i + 2) == combo then 
		    center = i + 1
  	  elseif i * (i + 3) == combo then 
		    center = i + 4
	    end
	  end
    if center > 5 then 
		  center = center - 5
	  end
	end
  return center
end

GetCostOfColour = function(object, colour)
-- returns the amount of mana of the selected color in object's cost
	local filter = Object():GetFilter()
	filter:Clear()
	filter:NotTargetted()
	filter:SetCardInstance(object)
	return filter:ChromaCount(colour)
end

GetFlashbackString = function(object)
-- returns the flashback mana cost string
	local cmc = object:GetConvertedManaCost()
	local total_cmc = cmc + IncManaCostF(object) - DecManaCostF(object)
	if total_cmc > 0 then
		local string = ""
		local amount = {}
		local cost_count = 0
		local hybrid_mana = 0
		local coloured_mana = 0		
		for i=0,5 do
			amount[i] = GetCostOfColour(object, i)
			cost_count = cost_count + amount[i]
			if i == 0 then
		    coloured_mana = cmc - amount[i]
		  end
		end
		if cost_count == cmc then
		-- not hybrid color
		  for j=1,5 do
			  if amount[j] > 0 then
	        if PhyrexianManaCost(object, j) == 1 then
		      -- phyrexian color
				    string = string..PhyrexianManaString(j, amount[j])
		      else
				    string = string..ManaString(j, amount[j])
			    end
			  end
		  end
		elseif cost_count > cmc then
		-- hybrid color
			hybrid_mana = cost_count - cmc
		  if coloured_mana > 0 then
		    local combo_colors = HybridColourCombo(object)
		    local center_color = HybridCenterColour(object)
			  if combo_colors > 1 then
		      string = string..HybridManaString(combo_colors, hybrid_mana)
		    end
			  if center_color > 0 then
		      string = string..ManaString(center_color, coloured_mana - hybrid_mana)
		    end
		  else
	      local n = DecManaCostF(object) - IncManaCostF(object)
		    if n < 0 then
		      n = 0
			  end
        local symbolindex = math.ceil(n/2)
		    coloured_mana = (cmc/2 - symbolindex) * 2
        if PermanentColour(object) == 1 then 
		      for j=1,5 do
			      if amount[j] - symbolindex > 0 then
				      string = string..HybridManaString(20 + j, amount[j] - symbolindex)
			      end
		      end
		    else
		      for k=1,5 do
    	      if (object:GetPlayer():CanAfford(ColourToString(k)) == 0 and symbolindex > 0) or (symbolindex + k > 5) then
              symbolindex = symbolindex - 1
		        else
				      string = string..HybridColourToString(20 + k)
			      end
		      end
		    end
		  end
		end		
		if total_cmc > coloured_mana then
			string = "{"..(total_cmc-coloured_mana).."}"..string
		end
		return string
	else
		return "{0}"
	end
end

GetCMCostString = function(object, flash)
-- returns the flashback mana cost string
	local cmc = object:GetConvertedManaCost()
	if cmc > 0 then
		local string = ""
		local amount = {}
		local cost_count = 0
		local hybrid_mana = 0
		local coloured_mana = 0		
		for i=0,5 do
			amount[i] = GetCostOfColour(object, i)
			cost_count = cost_count + amount[i]
			if i == 0 then
		    coloured_mana = cmc - amount[i]
		  end
		end
		if cost_count == cmc then
		-- not hybrid color
		  for j=1,5 do
			  if amount[j] > 0 then
	        if PhyrexianManaCost(object, j) == 1 then
		      -- phyrexian color
				    string = string..PhyrexianManaString(j, amount[j])
		      else
				    string = string..ManaString(j, amount[j])
			    end
			  end
		  end
		elseif cost_count > cmc then
		-- hybrid color
			hybrid_mana = cost_count - cmc
		  if coloured_mana > 0 then
		    local combo_colors = HybridColourCombo(object)
		    local center_color = HybridCenterColour(object)
			  if combo_colors > 1 then
		      string = string..HybridManaString(combo_colors, hybrid_mana)
		    end
			  if center_color > 0 then
		      string = string..ManaString(center_color, coloured_mana - hybrid_mana)
		    end
		  else
        local symbolindex = math.ceil(flash/2)
		    coloured_mana = cmc
        if PermanentColour(object) == 1 then 
		      for j=1,5 do
			      if amount[j] - symbolindex > 0 then
				      string = string..HybridManaString(20 + j, amount[j] - symbolindex)
			      end
		      end
		    else
		      for k=1,5 do
    	      if (object:GetPlayer():CanAfford(ColourToString(k)) == 0 and symbolindex > 0) or (symbolindex + k > 5) then
              symbolindex = symbolindex - 1
		        else
				      string = string..HybridColourToString(20 + k)
			      end
		      end
		    end
		  end
		end		
		if cmc > coloured_mana + flash then
			string = "{"..(cmc-coloured_mana-flash).."}"..string
		end
		return string
	else
		return "{0}"
	end
end

CanAffordColour = function(player, colour)
	local string = ""
	local amount = 0
	string = ColourToString(colour)
  while player:CanAfford(string) == 1 do
	  string = string..ColourToString(colour)
    amount = amount + 1
	end
	return amount
end

GetHandCostOfColour = function(player, colour)
	local filter = Object():GetFilter()
	filter:Clear()
	filter:NotTargetted()
	filter:SetPlayer( player )
	filter:SetZone( ZONE_HAND )
	return filter:ChromaCount(colour)
end

CostMarginOfColour = function(player, colour, index)
	local hand_cost = GetHandCostOfColour(player, colour)
	local total_mana = CanAffordColour(player, colour)
	if hand_cost - total_mana > index then
	  return index
	elseif hand_cost - total_mana > 0 then
	  return hand_cost - total_mana
	end
	return 0
end